/***********************************************************************
 * Top-level module to connect the testbench to the design under test.
 * Also generates the clock(s) used in the design and testbench.
 *
 **********************************************************************/

module top();  // top-level netlist to connect testbench to dut
  timeunit 1ns; timeprecision 1ns;

  logic  q1, q2, q3, q4, rst_;
  logic  clk;

  jcounter_test test (.q1(q1), .q2(q2), .q3(q3), .q4(q4),
                      .clk(clk), .rst_(rst_) );

  jcounter dut (.q1(q1), .q2(q2), .q3(q3), .q4(q4),
                .clk(clk), .rst_(rst_) );

  // test clocks
  initial begin
    clk <= 0;
    forever #10 clk = ~clk;
  end

endmodule: top

