/***********************************************************************
 * An RTL model of a 10-to-4 Priority BCD Encoder.
 *
 **********************************************************************/

module bcd_encoder (
  input  logic [9:1] decimal_in,
  output logic [3:0] bcd_out
);
  timeunit 1ns; timeprecision 1ns;

  always_comb begin
  // ADD 10-line to 4-line PRIORITY BCD ENCODER FUNCTIONALITY
// START OF SOLUTION...
    case (decimal_in) inside
      9'b1????????: bcd_out = 9;  // bit 9 is set
      9'b01???????: bcd_out = 8;  // bit 8 is set
      9'b001??????: bcd_out = 7;  // bit 7 is set
      9'b0001?????: bcd_out = 6;  // bit 6 is set
      9'b00001????: bcd_out = 5;  // bit 5 is set
      9'b000001???: bcd_out = 4;  // bit 4 is set
      9'b0000001??: bcd_out = 3;  // bit 3 is set
      9'b00000001?: bcd_out = 2;  // bit 2 is set
      9'b000000001: bcd_out = 1;  // bit 1 is set
      9'b000000000: bcd_out = 0;  // no bits are set
    endcase
// END OF SOLUTION
  end
endmodule
