/***********************************************************************
 * Package containing the typdef for an enumerated type to use as the
 * ALU opcode input port and opcode decoder. Also used by the testbench.
 *
 **********************************************************************/

package alu_opcodes;
  timeunit 1ns; timeprecision 1ns;
  typedef enum logic [2:0] {
    INVERT_A     = 3'h0,
    NEGATE_A     = 3'h1,
    INCREMENT_A  = 3'h2,
    A_PLUS_B     = 3'h3,
    A_MINUS_B    = 3'h4,
    A_XORED_B    = 3'h5,
    A_SHIFTED_B  = 3'h6,
    A_ROTATED_B  = 3'h7
  } opcode_t;
endpackage: alu_opcodes
