/***********************************************************************
 * A "slave processor" model, that does nothing but send and receive
 * values through an interface, and print message when something is
 * received.
 *
 **********************************************************************/

//`define FORCE_PARITY_ERROR  // uncomment to for parity errors

module proc2 (proc_ifc.bus_slave io);
  timeunit 1ns; timeprecision 1ns;

  always @(io.req or io.ack)
    begin
       wait (io.req)
       $display("Slave received a request");
       io.parity_check(io.data_master);

       io.data_slave = io.data_master;
       io.data_slave.opA--;
       io.data_slave.parity = io.parity_gen(io.data_slave);
       `ifdef FORCE_PARITY_ERROR
         io.data_slave.parity = 1;  //stick parity bit
      `endif
       $display("Slave is sending out some data");
       repeat($random % 3) @(negedge io.clk) ;  //delay 0 to 2 clock cycles
       io.done = 1;
       wait (io.ack)
       @(negedge io.clk) ;  //delay 1 clock cycle
       io.done = 0;
       wait (!io.req) ;
    end

endmodule
