/***********************************************************************
 * A "master processor" model, that does nothing but send and receive
 * values through an interface, and print message when something is
 * received.
 *
 **********************************************************************/

module proc1
  import type_defs_pkg::*;
  (proc_ifc.bus_master io);
  timeunit 1ns; timeprecision 1ns;

  always @(posedge io.clk or negedge io.rst)
    if (!io.rst)
      reset_data(io.data_master);
    else
       master_action();

  task reset_data (inout packet_t data);
     data = 0;
     data.parity = io.parity_gen(data);
  endtask

  task master_action;
    io.data_master.opA--;
    io.data_master.opB++;
    io.data_master.opcode++;
    io.data_master.parity = io.parity_gen(io.data_master);
    $display("\nMaster is sending out some data");
    io.req = 1;

    wait (io.done)
    @(negedge io.clk) ;  //delay 1 clock cycle
    io.ack = 1;
    $display("Master received some data back");
    io.parity_check(io.data_slave);

    wait (!io.done)
    @(negedge io.clk) ;  //delay 1 clock cycle
    io.ack = 0;
    io.req = 0;
  endtask

endmodule: proc1
