
class BaseTest;

  virtual tb_ifc v_io;
  Driver drv_h;
  Monitor mon_h;
  Generator gen_h;

  function new(virtual tb_ifc v_io);
    this.v_io = v_io;
    drv_h = new(v_io);
    mon_h = new(v_io);
    gen_h = new(drv_h);
  endfunction

  task run();
    $display("\nReseting the instruction register...");
    drv_h.reset();
    $display("\nWriting values to register stack...");
    gen_h.run(3);

    $display("\nNow run with Divide_by_zero transactions");
    gen_h.trn_h = DivideByZero::new();  // Insert new blueprint
    gen_h.run(3);

    // read back and display same three register locations
    $display("\nReading back the same register locations written...");
    mon_h.read_register(6);
  endtask

endclass: BaseTest