
class Monitor;

  virtual tb_ifc v_io;

  function new(virtual tb_ifc v_io);
    this.v_io = v_io;
  endfunction

  task read_register(int n);
    for (int i=0; i<n; i++) begin
      // Later labs will replace this loop with iterating through a
      // scoreboard to determine which addresses were written and
      // the expected values to be read back
      @(posedge v_io.clk);
      #1 v_io.read_pointer = i;
      #8 print_results();
    end
  endtask

  function void print_results();
    $display("Read from register location %2d: opcode = %0d (%5s) operand_a =%3d  operand_b =%3d", 
	     v_io.read_pointer, v_io.instruction_word.opc, v_io.instruction_word.opc.name(), v_io.instruction_word.op_a, v_io.instruction_word.op_b);
  endfunction


endclass : Monitor
