/***********************************************************************
 * A SystemVerilog RTL model of an instruction regisgter:
 * User-defined type definitions
 *
 **********************************************************************/
package instr_register_pkg;
  timeunit 1ns; timeprecision 1ns;

  typedef enum logic [3:0] {
  	ZERO,
    PASSA,
    PASSB,
    ADD,
    SUB,
    MULT,
    DIV,
    MOD
  } opcode_t;

  typedef logic signed [31:0] operand_t;
  
  typedef logic [4:0] address_t;
  
  typedef struct {
    opcode_t  opc;
    operand_t op_a;
    operand_t op_b;
  } instruction_t;

// new enum typedef to be used to allow amount of printing to be minimal 
// unless debug inforamtion is required (done in a simple way, but mimicing
//the more complex UVM functionality

  typedef enum {
    LOW,
    MEDIUM,
    HIGH,
    DEBUG
  } verbosity_t;

endpackage: instr_register_pkg
