
class Monitor extends Component;

  virtual tb_ifc v_io;
    mailbox #(Transaction) mon2scb_h;

  function new(virtual tb_ifc v_io);
    this.v_io = v_io;
  endfunction

  task run(int n);
    repeat (n) begin
      // Will always create a Tranaction class, as no need for the extra constraints of the 
      //extended class
      Transaction trn_h = new();
      @(posedge v_io.clk);
         while (v_io.load_en != 1'b1) begin
           @(posedge v_io.clk);
         end       
      #1 v_io.read_pointer = v_io.write_pointer;
      #8 print_results();
         trn_h.operand_a = v_io.instruction_word.op_a;
         trn_h.operand_b = v_io.instruction_word.op_b;
         trn_h.opcode = v_io.instruction_word.opc;
         trn_h.write_pointer = v_io.read_pointer;
         mon2scb_h.put(trn_h); // clone not needed as new transaction created everytime.
    end  
  endtask : run  

  // check() method removed, as checking now done in scoreboard.

  function void print_results();
    $timeformat(-9, 2, "ns", 6);
    if (verbosity > MEDIUM)
      $display("%t: Read from register location %2d: opcode = %0d (%5s) operand_a =%3d  operand_b =%3d", 
	     $realtime, v_io.read_pointer, v_io.instruction_word.opc, v_io.instruction_word.opc.name(), v_io.instruction_word.op_a, v_io.instruction_word.op_b);
  endfunction


endclass : Monitor
